function Binary_GA(Points_Matrix,PopNum,GenNum,CrossNum,MutNum,ElitistNum,Binary_Threshold,handles)

% global Elitist_Local_flag
% global Elitist_Global_flag
global Elitist_Points_flag

global Chromosome_Length_x
global Chromosome_Length_y
global Chromosome_Length

global PopNum_Binary_Mode

global Tournament_flag
global RouletteWheel_flag
global Ranking_flag
global TopParent_flag

global Crossover_SinglePoint_flag
global Crossover_TwoPoint_flag
% global Crossover_MultiPoint_flag
% global Crossover_Scattering_flag

global Mutation_BitWise_flag
global Mutation_Exchange_flag
global Mutation_Shift_flag

global k

[x, Coloumn]=size(Points_Matrix);

if(x<2)
    return
end

PopNum_Binary_Mode=dec2bin(PopNum);

MinMax=FindMinMax(Points_Matrix);

xdif = MinMax(2) - MinMax(1);
ydif = MinMax(4) - MinMax(3);

xdif_Binary=dec2bin(xdif);
ydif_Binary=dec2bin(ydif);

Chromosome_Length_x=size(xdif_Binary,2);
Chromosome_Length_y=size(ydif_Binary,2);
Chromosome_Length=[Chromosome_Length_x,Chromosome_Length_y];

Population_x=Initialize_Population_Binary(Chromosome_Length_x,PopNum,handles);
Population_y=Initialize_Population_Binary(Chromosome_Length_y,PopNum,handles);

All_Population=[Population_x Population_y];

Counter_found=1;
Found_Mode=1;
Local_c=1;

set(handles.Counter,'String','');
set(handles.Found,'String','');
set(handles.MCC_Fitness,'String','');
set(handles.GA_Best_Fitness,'String','');
set(handles.GA_Ave_Fitness,'String','');
set(handles.Radius_Diff,'String','');
set(handles.Center_Diff,'String','');

for i=1:PopNum
    Solution(1,1:Chromosome_Length_x) = Population_x(i,:);
    Solution(2,1:Chromosome_Length_y) = Population_y(i,:);
    c1=num2str(Solution(1,1:Chromosome_Length_x));
    c2=num2str(Solution(2,1:Chromosome_Length_y));
    S(1)=bin2dec(c1);
    S(2)=bin2dec(c2);
    All_Population(i,Chromosome_Length_x+Chromosome_Length_y+1)=Fitness(S,Points_Matrix);
end

Best_Solution(1,(Chromosome_Length_x+Chromosome_Length_y)+1)=100000;

Best_Solution = FindBestSolution_Binary(All_Population,Best_Solution,Chromosome_Length);

c=1;

Fitness_Average(c)=Find_Average_Fitness_Binary(All_Population,Chromosome_Length);
Fitness_Best(c)=Best_Solution(1,(Chromosome_Length_x+Chromosome_Length_y)+1);

if Elitist_Points_flag==0
    ElitistNum=0;
end

while (c<=GenNum)
    
    axis(handles.WorkSpace,[0 600 0 600]);
    
    Sorted_Population = sortrows(All_Population,(Chromosome_Length_x+Chromosome_Length_y)+1);
    Offspring_Population=ones(PopNum,(Chromosome_Length_x+Chromosome_Length_y)+1);
    
    k=1;
    k=k+ElitistNum;
    
    if Elitist_Points_flag==1
        for i=1:ElitistNum
            Offspring_Population(i,:)=Sorted_Population(i,:);
        end
    end
    %     else
    %         if Elitist_Global_flag==1
    %             continue;
    %         else
    %             if Elitist_Local_flag==1
    %                 continue;
    %             end
    %         end
    %     end
    
    while(k<=((100-CrossNum)*.01)*PopNum)
        
        if Tournament_flag==1
            Offspring_Solution=Selection_Tournament_Binary(Chromosome_Length,PopNum,Sorted_Population,handles);
        else
            if RouletteWheel_flag==1
                Offspring_Solution = Selection_RouletteWheel_Binary(Chromosome_Length,PopNum,Sorted_Population,handles);
            else
                if TopParent_flag==1
                    Offspring_Solution= Selection_TopParent(PopNum,Sorted_Population,handles);
                else
                    if Ranking_flag==1
                        Offspring_Solution=Selection_Ranking_Binary(Chromosome_Length,PopNum,Sorted_Population,handles);
                    end
                end
            end
        end
        
        c1=num2str(Offspring_Solution(1,1:Chromosome_Length(1)));
        c2=num2str(Offspring_Solution(1,Chromosome_Length(1)+1:(Chromosome_Length_x+Chromosome_Length_y)));
        S(1)=bin2dec(c1);
        S(2)=bin2dec(c2);
        S(3)=Fitness(S,Points_Matrix);
        
        Offspring_Population(k,1:Chromosome_Length(1))=Offspring_Solution(1,1:Chromosome_Length(1));
        Offspring_Population(k,Chromosome_Length(1)+1:(Chromosome_Length_x+Chromosome_Length_y))=Offspring_Solution(1,Chromosome_Length(1)+1:(Chromosome_Length_x+Chromosome_Length_y));
        Offspring_Population(k,(Chromosome_Length_x+Chromosome_Length_y)+1)=S(3);
             
        k = k+1;
        
    end
    
    while(k<=PopNum)
                
        if Tournament_flag==1
            Tournament_Output1 = Selection_Tournament_Binary(Chromosome_Length,PopNum,Sorted_Population,handles);
            Tournament_Output2 = Selection_Tournament_Binary(Chromosome_Length,PopNum,Sorted_Population,handles);
        else
            if RouletteWheel_flag==1
                RouletteWheel_Output1 = Selection_RouletteWheel_Binary(Chromosome_Length,PopNum,Sorted_Population,handles);
                RouletteWheel_Output2 = Selection_RouletteWheel_Binary(Chromosome_Length,PopNum,Sorted_Population,handles);
            else
                if TopParent_flag==1
                    TopParent_Output1 = Selection_TopParent(PopNum,Sorted_Population,handles);
                    TopParent_Output2 = Selection_TopParent(PopNum,Sorted_Population,handles);
                else
                    if Ranking_flag==1
                        Ranking_Output1 = Selection_Ranking_Binary(Chromosome_Length,PopNum,Sorted_Population,handles);
                        Ranking_Output2 = Selection_Ranking_Binary(Chromosome_Length,PopNum,Sorted_Population,handles);
                    end
                end
            end
        end
        
        if Crossover_SinglePoint_flag==1
            if Tournament_flag==1
                Offspring_Solution=Crossover_SinglePoint(Tournament_Output1,Tournament_Output2,Chromosome_Length,handles);
            else
                if RouletteWheel_flag==1
                    Offspring_Solution=Crossover_SinglePoint(RouletteWheel_Output1,RouletteWheel_Output2,Chromosome_Length,handles);
                else
                    if TopParent_flag==1
                        Offspring_Solution=Crossover_SinglePoint(TopParent_Output1,TopParent_Output2,Chromosome_Length,handles);
                    else
                        if Ranking_flag==1
                            Offspring_Solution=Crossover_SinglePoint(Ranking_Output1,Ranking_Output2,Chromosome_Length,handles);
                        end
                    end
                end
            end
        end
        
        if Crossover_TwoPoint_flag==1
            if Tournament_flag==1
                Offspring_Solution=Crossover_TwoPoint(Tournament_Output1,Tournament_Output2,Chromosome_Length,handles);
            else
                if RouletteWheel_flag==1
                    Offspring_Solution=Crossover_TwoPoint(RouletteWheel_Output1,RouletteWheel_Output2,Chromosome_Length,handles);
                else
                    if TopParent_flag==1
                        Offspring_Solution=Crossover_TwoPoint(TopParent_Output1,TopParent_Output2,Chromosome_Length,handles);
                    else
                        if Ranking_flag==1
                            Offspring_Solution=Crossover_TwoPoint(Ranking_Output1,Ranking_Output2,Chromosome_Length,handles);
                        end
                    end
                end
            end
        end
        
        if (rand<MutNum*.01)
            if Mutation_BitWise_flag==1
                if Crossover_SinglePoint_flag==1
                    Offspring_Solution = Mutation_BitWise(Offspring_Solution,Chromosome_Length,handles);
                else
                    if Crossover_TwoPoint_flag==1
                        Offspring_Solution = Mutation_BitWise(Offspring_Solution,Chromosome_Length,handles);
                    end
                end
            end
            if Mutation_Exchange_flag==1
                if Crossover_SinglePoint_flag==1
                    Offspring_Solution = Mutation_Exchange(Offspring_Solution,Chromosome_Length,handles);
                else
                    if Crossover_TwoPoint_flag==1
                        Offspring_Solution = Mutation_Exchange(Offspring_Solution,Chromosome_Length,handles);
                    end
                end
            end
            if Mutation_Shift_flag==1
                if Crossover_SinglePoint_flag==1
                    Offspring_Solution = Mutation_Shift(Offspring_Solution,Chromosome_Length,handles);
                else
                    if Crossover_TwoPoint_flag==1
                        Offspring_Solution = Mutation_Shift(Offspring_Solution,Chromosome_Length,handles);
                    end
                end
            end
        end       
        
        c1=num2str(Offspring_Solution(1,1:Chromosome_Length(1)));
        c2=num2str(Offspring_Solution(1,Chromosome_Length(1)+1:(Chromosome_Length_x+Chromosome_Length_y)));
        S(1)=bin2dec(c1);
        S(2)=bin2dec(c2);
        S(3)=Fitness(S,Points_Matrix);
        
        Offspring_Population(k,1:Chromosome_Length(1))=Offspring_Solution(1,1:Chromosome_Length(1));
        Offspring_Population(k,Chromosome_Length(1)+1:(Chromosome_Length_x+Chromosome_Length_y))=Offspring_Solution(1,Chromosome_Length(1)+1:(Chromosome_Length_x+Chromosome_Length_y));
        Offspring_Population(k,(Chromosome_Length_x+Chromosome_Length_y)+1)=S(3);
                
        if Crossover_SinglePoint_flag==1
            if Tournament_flag==1
                Offspring_Solution=Crossover_SinglePoint(Tournament_Output1,Tournament_Output2,Chromosome_Length,handles);
            else
                if RouletteWheel_flag==1
                    Offspring_Solution=Crossover_SinglePoint(RouletteWheel_Output1,RouletteWheel_Output2,Chromosome_Length,handles);
                else
                    if TopParent_flag==1
                        Offspring_Solution=Crossover_SinglePoint(TopParent_Output1,TopParent_Output2,Chromosome_Length,handles);
                    else
                        if Ranking_flag==1
                            Offspring_Solution=Crossover_SinglePoint(Ranking_Output1,Ranking_Output2,Chromosome_Length,handles);
                        end
                    end
                end
            end
        end
        
        if Crossover_TwoPoint_flag==1
            if Tournament_flag==1
                Offspring_Solution=Crossover_TwoPoint(Tournament_Output1,Tournament_Output2,Chromosome_Length,handles);
            else
                if RouletteWheel_flag==1
                    Offspring_Solution=Crossover_TwoPoint(RouletteWheel_Output1,RouletteWheel_Output2,Chromosome_Length,handles);
                else
                    if TopParent_flag==1
                        Offspring_Solution=Crossover_TwoPoint(TopParent_Output1,TopParent_Output2,Chromosome_Length,handles);
                    else
                        if Ranking_flag==1
                            Offspring_Solution=Crossover_TwoPoint(Ranking_Output1,Ranking_Output2,Chromosome_Length,handles);
                        end
                    end
                end
            end
        end
        
        if (rand<MutNum*.01)
            if Mutation_BitWise_flag==1
                if Crossover_SinglePoint_flag==1
                    Offspring_Solution = Mutation_BitWise(Offspring_Solution,Chromosome_Length,handles);
                else
                    if Crossover_TwoPoint_flag==1
                        Offspring_Solution = Mutation_BitWise(Offspring_Solution,Chromosome_Length,handles);
                    end
                end
            end
            if Mutation_Exchange_flag==1
                if Crossover_SinglePoint_flag==1
                    Offspring_Solution = Mutation_Exchange(Offspring_Solution,Chromosome_Length,handles);
                else
                    if Crossover_TwoPoint_flag==1
                        Offspring_Solution = Mutation_Exchange(Offspring_Solution,Chromosome_Length,handles);
                    end
                end
            end
            if Mutation_Shift_flag==1
                if Crossover_SinglePoint_flag==1
                    Offspring_Solution = Mutation_Shift(Offspring_Solution,Chromosome_Length,handles);
                else
                    if Crossover_TwoPoint_flag==1
                        Offspring_Solution = Mutation_Shift(Offspring_Solution,Chromosome_Length,handles);
                    end
                end
            end
        end
        
        c1=num2str(Offspring_Solution(1,1:Chromosome_Length(1)));
        c2=num2str(Offspring_Solution(1,Chromosome_Length(1)+1:(Chromosome_Length_x+Chromosome_Length_y)));
        S(1)=bin2dec(c1);
        S(2)=bin2dec(c2);
        S(3)=Fitness(S,Points_Matrix);
        
        Offspring_Population(k+1,1:Chromosome_Length(1))=Offspring_Solution(1,1:Chromosome_Length(1));
        Offspring_Population(k+1,Chromosome_Length(1)+1:(Chromosome_Length_x+Chromosome_Length_y))=Offspring_Solution(1,Chromosome_Length(1)+1:(Chromosome_Length_x+Chromosome_Length_y));
        Offspring_Population(k+1,(Chromosome_Length_x+Chromosome_Length_y)+1)=S(3);
        
        k=k+2;
    end
    
    for i=1:PopNum
        All_Population(i,1:Chromosome_Length(1))= Offspring_Population(i,1:Chromosome_Length(1));
        All_Population(i,Chromosome_Length(1)+1:(Chromosome_Length_x+Chromosome_Length_y))= Offspring_Population(i,Chromosome_Length(1)+1:(Chromosome_Length_x+Chromosome_Length_y));
        All_Population(i,(Chromosome_Length_x+Chromosome_Length_y)+1)= Offspring_Population(i,(Chromosome_Length_x+Chromosome_Length_y)+1);
    end
    
    Best_Solution = FindBestSolution_Binary(All_Population,Best_Solution,Chromosome_Length);
       
    Fitness_Average(c)=Find_Average_Fitness_Binary(All_Population,Chromosome_Length);
    Fitness_Best(c)=Best_Solution(1,(Chromosome_Length_x+Chromosome_Length_y)+1);
    
    for i=1:c
        Generation(i)=i;
    end
    
    cla(handles.DiagramAxes,'reset');
    
    p=plot(handles.DiagramAxes,Generation,Fitness_Average);
    set(p,'Color','blue','LineWidth',2);
    
    hold(handles.DiagramAxes,'on');
    
    q=plot(handles.DiagramAxes,Generation,Fitness_Best);
    set(q,'Color','red','LineWidth',2);
    
    hold(handles.DiagramAxes,'on');
    
    MinCC=EnclosingCircle(Points_Matrix);
    MccSol(c)=MinCC(1,3);
    
    q=plot(handles.DiagramAxes,Generation,MccSol);
    set(q,'Color','green','LineWidth',2);
    hold(handles.DiagramAxes,'on');
    
    n1=Best_Solution(1,1:Chromosome_Length(1));
    n2=Best_Solution(1,Chromosome_Length(1)+1:(Chromosome_Length_x+Chromosome_Length_y));
    m1=num2str(n1);
    m2=num2str(n2);
    cx=bin2dec(m1);
    cy=bin2dec(m2);
    r=Best_Solution(1,(Chromosome_Length_x+Chromosome_Length_y)+1);
    
    cla(handles.WorkSpace,'reset');
    
    x_mcc=MinCC(1,1);
    y_mcc=MinCC(1,2);
    r_mcc=MinCC(1,3);
    
    
    DrawPoints(Points_Matrix,handles);
    DrawCircle(handles,x_mcc,y_mcc,r_mcc,1);
    hold(handles.WorkSpace,'on');
    DrawCircle(handles,cx,cy,r,2);
    
    m(c)=sqrt((MinCC(1,1)-cx)^2 + (MinCC(1,2)-cy)^2);
    
    n(c)=abs(MccSol(c)- Fitness_Best(c));    
    
    set(handles.MCC_Fitness,'String',MccSol(c));
    set(handles.GA_Best_Fitness,'String',Fitness_Best(c));
    set(handles.GA_Ave_Fitness,'String',Fitness_Average(c));
    set(handles.Counter,'String',c);
    
    if c>=2
        if m(c)<m(Local_c)
            Counter_found=1;
        end
    end
    
    if m(c)<=Binary_Threshold && Counter_found==1
        set(handles.Center_Diff,'String',m(c));
        set(handles.Radius_Diff,'String',n(c));
        set(handles.Found,'String',c);
        Counter_found=0;
        Found_Mode=0;
        Local_c=c;
    end
    
    pause(0.000001);
    c=c+1;
    
end

if Found_Mode==1
    Min_n=min(n);
    Min_m=min(m);
    set(handles.Radius_Diff,'String',Min_n);
    set(handles.Center_Diff,'String',Min_m);
    set(handles.Found,'String','Not Found');
end

end
