function Real_GA(Points_Matrix,PopNum,GenNum,CrossNum,MutNum,ElitistNum,Real_Threshold,handles)

% global Elitist_Local_flag
% global Elitist_Global_flag
global Elitist_Points_flag

global Tournament_flag
global RouletteWheel_flag
global Ranking_flag
global TopParent_flag

global Crossover_Linear_flag
global Crossover_Naive_flag

global Mutation_Uniform_flag
% global Mutation_NonUniform_flag
% global Mutation_Guassian_flag
% global Mutation_Boundary_flag

global k

[x, Coloumn]=size(Points_Matrix);

if(x<2)
    return
end

MinMax=FindMinMax(Points_Matrix);

Population=Initialize_Population_Real(PopNum,MinMax);

for i=1:PopNum
    Solution(1) = Population(i,1);
    Solution(2) = Population(i,2);
    Population(i,3)=Fitness(Solution,Points_Matrix);
end

Best_Solution(1,3)=100000;
Best_Solution = FindBestSolution_Real(Population,Best_Solution);

c=1;

Fitness_Average(c)=Find_Average_Fitness_Real(Population);
Fitness_Best(c)=Best_Solution(1,3);

if Elitist_Points_flag==0
    ElitistNum=0;
end

Counter_found=1;
Found_Mode=1;
Local_c=1;

set(handles.Counter,'String','');
set(handles.Found,'String','');
set(handles.MCC_Fitness,'String','');
set(handles.GA_Best_Fitness,'String','');
set(handles.GA_Ave_Fitness,'String','');
set(handles.Radius_Diff,'String','');
set(handles.Center_Diff,'String','');

while (c<=GenNum)
    
    axis(handles.WorkSpace,[0 600 0 600]);
    
    Sorted_Population=sortrows(Population,3);
    Offspring_Population=ones(PopNum,3);
    
    k=1;
    k=k+ElitistNum;
        
    if Elitist_Points_flag==1
        for i=1:ElitistNum
            Offspring_Population(i,:)=Sorted_Population(i,:);
        end
    end
    %     else
    %         if Elitist_Global_flag==1
    %             continue;
    %         else
    %             if Elitist_Local_flag==1
    %                 continue;
    %             end
    %         end
    %     end
       
    while(k<=((100-CrossNum)*.01)*PopNum)
        
        if Tournament_flag==1
            Offspring_Solution=Selection_Tournament(PopNum,Sorted_Population,handles);
        else
            if RouletteWheel_flag==1
                Offspring_Solution = Selection_RouletteWheel(PopNum,Sorted_Population,handles);
            else
                if TopParent_flag==1
                    Offspring_Solution = Selection_TopParent(PopNum,Sorted_Population,handles);
                else
                    if Ranking_flag==1
                        Offspring_Solution=Selection_Ranking(PopNum,Sorted_Population,handles);
                    end
                end
            end
        end
        
        Offspring_Population(k,1)=Offspring_Solution(1);
        Offspring_Population(k,2)=Offspring_Solution(2);
        Offspring_Population(k,3)=Offspring_Solution(3);
        
        k = k+1;
        
    end
    
    while(k<=PopNum)
                
        if Tournament_flag==1
            Tournament_Output1 = Selection_Tournament(PopNum,Sorted_Population,handles);
            Tournament_Output2 = Selection_Tournament(PopNum,Sorted_Population,handles);
        else
            if RouletteWheel_flag==1
                RouletteWheel_Output1 = Selection_RouletteWheel(PopNum,Sorted_Population,handles);
                RouletteWheel_Output2 = Selection_RouletteWheel(PopNum,Sorted_Population,handles);
            else
                if TopParent_flag==1
                    TopParent_Output1 = Selection_TopParent(PopNum,Sorted_Population,handles);
                    TopParent_Output2 = Selection_TopParent(PopNum,Sorted_Population,handles);
                else
                    if Ranking_flag==1
                        Ranking_Output1 = Selection_Ranking(PopNum,Sorted_Population,handles);
                        Ranking_Output2 = Selection_Ranking(PopNum,Sorted_Population,handles);
                    end
                end
            end
        end
        
        if Crossover_Linear_flag==1
            lambda=rand;
            if(rand>0.5)
                lambda=lambda+0.5;
            else
                lambda=lambda-0.5;
            end
            Cross_Linear_Mode=1;
            if Tournament_flag==1
                Offspring_Solution=Crossover_Linear(Cross_Linear_Mode,lambda,Tournament_Output1, Tournament_Output2,handles);
            else
                if RouletteWheel_flag==1
                    Offspring_Solution=Crossover_Linear(Cross_Linear_Mode,lambda,RouletteWheel_Output1,RouletteWheel_Output2,handles);
                else
                    if TopParent_flag==1
                        Offspring_Solution=Crossover_Linear(Cross_Linear_Mode,lambda,TopParent_Output1,TopParent_Output2,handles);
                    else
                        if Ranking_flag==1
                            Offspring_Solution=Crossover_Linear(Cross_Linear_Mode,lambda,Ranking_Output1,Ranking_Output2,handles);
                        end
                    end
                end
            end
        end
        
        if Crossover_Naive_flag==1
            Cross_Naive_Mode=1;
            if Tournament_flag==1
                Offspring_Solution=Crossover_Naive(Cross_Naive_Mode,Tournament_Output1, Tournament_Output2,handles);
            else
                if RouletteWheel_flag==1
                    Offspring_Solution=Crossover_Naive(Cross_Naive_Mode,RouletteWheel_Output1,RouletteWheel_Output2,handles);
                else
                    if TopParent_flag==1
                        Offspring_Solution=Crossover_Naive(Cross_Naive_Mode,TopParent_Output1,TopParent_Output2,handles);
                    else
                        if Ranking_flag==1
                            Offspring_Solution=Crossover_Naive(Cross_Naive_Mode,Ranking_Output1,Ranking_Output2,handles);
                        end
                    end
                end
            end
        end
        
        if (rand<MutNum*.01)
            if Mutation_Uniform_flag==1
                Offspring_Solution = Mutation_Uniform(MinMax,handles);
            end
        end
        Solution(3)=Fitness(Offspring_Solution,Points_Matrix);
        
        Offspring_Population(k,1)=Offspring_Solution(1);
        Offspring_Population(k,2)=Offspring_Solution(2);
        Offspring_Population(k,3)=Solution(3);
               
        if Crossover_Linear_flag==1
            Cross_Linear_Mode=2;
            if Tournament_flag==1
                Offspring_Solution=Crossover_Linear(Cross_Linear_Mode,lambda,Tournament_Output1, Tournament_Output2,handles);
            else
                if RouletteWheel_flag==1
                    Offspring_Solution=Crossover_Linear(Cross_Linear_Mode,lambda,RouletteWheel_Output1,RouletteWheel_Output2,handles);
                else
                    if TopParent_flag==1
                        Offspring_Solution=Crossover_Linear(Cross_Linear_Mode,lambda,TopParent_Output1,TopParent_Output2,handles);
                    else
                        if Ranking_flag==1
                            Offspring_Solution=Crossover_Linear(Cross_Linear_Mode,lambda,Ranking_Output1,Ranking_Output2,handles);
                        end
                    end
                end
            end
        end
        
        if Crossover_Naive_flag==1
            Cross_Naive_Mode=2;
            if Tournament_flag==1
                Offspring_Solution=Crossover_Naive(Cross_Naive_Mode,Tournament_Output1, Tournament_Output2,handles);
            else
                if RouletteWheel_flag==1
                    Offspring_Solution=Crossover_Naive(Cross_Naive_Mode,RouletteWheel_Output1,RouletteWheel_Output2,handles);
                else
                    if TopParent_flag==1
                        Offspring_Solution=Crossover_Naive(Cross_Naive_Mode,TopParent_Output1,TopParent_Output2,handles);
                    else
                        if Ranking_flag==1
                            Offspring_Solution=Crossover_Naive(Cross_Naive_Mode,Ranking_Output1,Ranking_Output2,handles);
                        end
                    end
                end
            end
        end
             
        if (rand<MutNum*.01)
            if Mutation_Uniform_flag==1
                Offspring_Solution = Mutation_Uniform(MinMax,handles);
            end
        end
        Solution(3)=Fitness(Offspring_Solution,Points_Matrix);
        
        Offspring_Population(k+1,1)=Offspring_Solution(1);
        Offspring_Population(k+1,2)=Offspring_Solution(2);
        Offspring_Population(k+1,3)=Solution(3);
                
        k=k+2;

    end
    
    for i=1:PopNum
        Population(i,1)= Offspring_Population(i,1);
        Population(i,2)= Offspring_Population(i,2);
        Population(i,3)= Offspring_Population(i,3);
    end
    
    Best_Solution = FindBestSolution_Real(Population,Best_Solution);
    
    
    Fitness_Average(c)=Find_Average_Fitness_Real(Population);
    Fitness_Best(c)=Best_Solution(1,3);
    
    for i=1:c
        Generation(i)=i;
    end
    
    cla(handles.DiagramAxes,'reset');
    
    p=plot(handles.DiagramAxes,Generation,Fitness_Average);
    set(p,'Color','blue','LineWidth',2);
    
    hold(handles.DiagramAxes,'on');
    
    q=plot(handles.DiagramAxes,Generation,Fitness_Best);
    set(q,'Color','red','LineWidth',2);
    
    hold(handles.DiagramAxes,'on');
    
    MinCC=EnclosingCircle(Points_Matrix);
    MccSol(c)=MinCC(1,3);
    
    q=plot(handles.DiagramAxes,Generation,MccSol);
    set(q,'Color','green','LineWidth',2);
    hold(handles.DiagramAxes,'on');
    
    cla(handles.WorkSpace,'reset');
    axis(handles.WorkSpace,[0 600 0 600]);
    DrawPoints(Points_Matrix,handles);
    
    x_mcc=MinCC(1,1);
    y_mcc=MinCC(1,2);
    r_mcc=MinCC(1,3);
    
    cx=Best_Solution(1,1);
    cy=Best_Solution(1,2);
    r=Best_Solution(1,3);
    
    DrawCircle(handles,x_mcc,y_mcc,r_mcc,1);
    hold(handles.WorkSpace,'on');
    DrawCircle(handles,cx,cy,r,2);
    
    m(c)=sqrt((MinCC(1,1)-cx)^2 + (MinCC(1,2)-cy)^2);
    
    n(c)=abs(MccSol(c) - Fitness_Best(c));
    
    set(handles.MCC_Fitness,'String',MccSol(c));
    set(handles.GA_Best_Fitness,'String',Fitness_Best(c));
    set(handles.GA_Ave_Fitness,'String',Fitness_Average(c));
    set(handles.Counter,'String',c);
     
    if c>=2
        if m(c)<m(Local_c)
            Counter_found=1;
        end
    end
    
    if  m(c)<=Real_Threshold && Counter_found==1
        set(handles.Radius_Diff,'String',n(c));
        set(handles.Center_Diff,'String',m(c));
        set(handles.Found,'String',c);
        Counter_found=0;
        Found_Mode=0;
        Local_c=c;
    end
    
    pause(0.000001);
    c=c+1;
    
end

if Found_Mode==1
    Min_n=min(n);
    Min_m=min(m);
    set(handles.Radius_Diff,'String',Min_n);
    set(handles.Center_Diff,'String',Min_m);
    set(handles.Found,'String','Not Found');
end

end